;***set tabs to 9 spaces***
;
;
;
; +----------------------------------------------------------------+
; |    "Chessboard Zoomer 256b" by CyberBrain/NoName 16/06/2005.   !
; !                                                                :
; :   the source 4 da second chessboardzoomer in 256b on the C64!  |
;          -  -- --- ----------------------------------------------+
;
;              assemble with ca65. (www.cc65.org)
;
;                      lame code rulez!
;
;
; 


	.debuginfo +
	.feature labels_without_colons 	;<- man behver ikke bruge kolon efter labels (labels skal starte p 1st char)
	.feature pc_assignment	    	;<- man kan skrive *=xxxx istedetfor .org xxxx 
	*=$0801
	.word *
	*=$0801

xx	= $ff
xxxx	= $ffff

charset1 = $2000	; stuff will be plotted here 
charset2 = $2800	; charset2 will contain the reverse of charset
chessxpos= 4	; xposition of the chessboard on the screen. (sane values are 0-39)


temp	= $02	; used for centering the zoom-point

feltXSize  = $2c    ;xsize of each skak-felt. (actually y-size too) VALUE MUST BE >=8!
feltColorX = $66    ;black (=$26) or white (=$24)	(other values are illegal)   (value will be put into $D018)
feltColorY = $ab    ;black (=$00) or white (=$FF)	(other values are illegal)   (value will be plotted)

numrasterlines = 193+1-8
D011init = %00011011

basic	; inform user how many basic bytes that are free, when entering the secret park
	.byte $0c, $08, $00, $00  ,$9e, $20 ,$32 ,$30  ,$36 ,$32 ,$00 ,$00  ,$00

.macro EorFeltColorXByFF
	jsr $BFB8
.endmacro

.macro EorFeltColorYByA_trashA7_AA	; 28 cycles
	jsr $EF65
.endmacro


.macro CenterChessboard
.proc
	;calculate: (128-xsize/2)/xsize
	;------------------------------
	lda #0		;128*2
	sec			
	sbc <feltXSize	;xsize/2*2
	lsr
	sta <temp	;=128-xsize/2
	
	lda #%00011010
	sta <feltColorY
	lda #0
	sta <feltColorX
	
	;divide temp by xsize (well, kind of), and find start-colors of feltColorX and feltColorY
loop	pha

	lda #%00000010
	EorFeltColorYByA_trashA7_AA
	
	EorFeltColorXByFF
	pla

	clc
	adc <feltXSize
	cmp <temp
	bcc loop

	;get remainder (= amount of pixels for startxcnt of the leftmost skak-felt)
	;-------------
;	sec
	sbc <temp
	sta <temp
		
.endproc
.endmacro


.macro DrawX
.proc
	CenterChessboard

;	lda <temp
;	sec
	sbc <feltXSize
	tay

	;plot the shit	
	ldx #0
loop	
	lda <feltColorX	;<- $00 or $FF
	pha		;<- top of stack is the bit-pattern to be plotted (either solid ($00 or $FF) or nonsolid)
	
	;y+=8
	tya
;	clc
	adc #8
	tay
	bmi plot
	
plotnonsolid ; if y>=0 : we can't just plot a solid color ($00 or $FF) so:
             ;           - change feltColor: black<->white
             ;           - if new_feltColor = Black : plot pattern from whiteTab,y
	    ;             else                     : plot pattern from blackTab,y
             ;           - y := y - feltXSize
	pla
	eor blackTab,y ; is being eor'ed by either $00 (black) or $FF (white)
	pha

	EorFeltColorXByFF

	tya
;	sec
	sbc <feltXSize
	tay

plot	pla
	sta charset1+7+chessxpos*8,x
         eor #$FF
         sta charset2+7+chessxpos*8,x
         
         ;to make the sides blue $FF has to be plotted in the sides (but *only* on the 7th pixelline)
         lda #$FF
         sta charset1+7+(chessxpos+32)*8,x
         sta charset1+7+(chessxpos-32)*8,x
         sta charset2+7+(chessxpos+32)*8,x
         sta charset2+7+(chessxpos-32)*8,x         

	txa
;	clc
	adc #8
	tax
	bne loop
	
.endproc
.endmacro


.macro Waste12Cycles
	jsr $E08C
.endmacro

.macro Waste14Cycles_INX
	jsr $E110
.endmacro

.macro Waste14Cycles_trashA
	jsr $E3B7
.endmacro

.macro Waste18Cycles_trashA
	jsr $E3B4
.endmacro

.macro Waste32Cycles_trash63_64_65_70
	jsr $B93E
.endmacro


.macro ChessBoard
.proc
	lda <feltXSize
;	sec
	sbc <temp
	tay	

	ldx #D011init&%111

	lda #15
	sta $d021

loop	txa
	and #%00000111
	ora #D011init&%11111000
	sta $d011

	lda <feltColorY
	sta $d018

	dey
	beq change
nochange	Waste32Cycles_trash63_64_65_70
	jmp jump

change	ldy feltXSize
	lda #%00000010
	EorFeltColorYByA_trashA7_AA ;28 cycles
	
jump	inx
	cpx #numrasterlines + (D011init&%111)
	bne loop

	;make the lower and upper part of the mini-border blue
	lda #6
	sta $d021
.endproc
.endmacro


.macro SetupScreen
.proc
	ldx #0
loop	txa
	sta $0400,x
	lda #6
	sta $d800,x
	lda #$00
	sta charset1,x
	sta charset1+$100,x
	sta charset2,x
	sta charset2+$100,x
	inx
	bne loop
	
	;makes the foreground-color black, EXCEPT for the left/right side
	txa ; lda #0
	ldx #31
loop2	sta $d800+chessxpos,x
	dex
	bpl loop2

.endproc
.endmacro


.macro Main
.proc
	sei
	SetupScreen

loop	;move chessboard
sto	inc <feltXSize
	lda <feltXSize
	and #127
	cmp #9
	bcs jump
	lda sto
	eor #%00100000
	sta sto
jump	
	DrawX

back	lda #$30+%011-1
	cmp $d012
	bne *-3
	lda $d011
	bmi back
	
	dec $d011
	
	;timing...
	ldx #87+1-2-1-1+1
	dex
	bne *-1	;delay=2+(5*x)-1 <=> x=(delay-1)/5
	
	ChessBoard
		
	jmp loop
.endproc
.endmacro

	Main

;--------------------------------------------------------------------------------------------------------------------------------	

blackTab	.byte %00000001
	.byte %00000011
	.byte %00000111
	.byte %00001111
	.byte %00011111
	.byte %00111111
	.byte %01111111
	.byte %11111111

;whiteTab.byte %11111110 ; is just equal to blackTab eor $FF 
;	.byte %11111100
;	.byte %11111000
;	.byte %11110000
;	.byte %11100000
;	.byte %11000000
;	.byte %10000000
;	.byte %00000000

;--------------------------------------------------------------------------------------------------------------------------------